require("AnAL")

function love.load()
	gamestate = "menu"

	--SET UP ANIMATION
	local img  = love.graphics.newImage("ANIMATIONS/explosion.png")
	anim = newAnimation(img, 96, 96, 0.1, 0)
	--anim:setMode("bounce")
	--LOAD MENU IMAGES
	button_start = love.graphics.newImage("IMAGES/button_start.png")
	button_start_active = love.graphics.newImage("IMAGES/button_start_active.png")
	button_rules = love.graphics.newImage("IMAGES/button_rules.png")
	button_rules_active = love.graphics.newImage("IMAGES/button_rules_active.png")
	button_quit = love.graphics.newImage("IMAGES/button_quit.png")
	button_quit_active = love.graphics.newImage("IMAGES/button_quit_active.png")
	--LOAD GAME IMAGES
	brick = love.graphics.newImage("IMAGES/bricks2.png")
	ladder = love.graphics.newImage("IMAGES/ladder.png")
	--BLONDE IMAGES
	blonde_up = love.graphics.newImage("IMAGES/blonde_up.png")
	blonde_right = love.graphics.newImage("IMAGES/blonde_right.png")
	blonde_down = love.graphics.newImage("IMAGES/knight_front.png")
	blonde_left = love.graphics.newImage("IMAGES/blonde_left.png")
	--REDHEAD IMAGES
	red_up = love.graphics.newImage("IMAGES/red_up.png")
	red_right = love.graphics.newImage("IMAGES/red_right.png")
	red_down = love.graphics.newImage("IMAGES/red_down.png")
	red_left = love.graphics.newImage("IMAGES/red_left.png")
	--LOAD GAME SOUNDS
	soundVictory = love.audio.newSource("victory.mp3", "static")
	--SET TIMER DATA
	startTime = love.timer.getTime()
	currentTime = love.timer.getTime()
	--SET GAME DATA
	love.graphics.setColor( 100, 100, 100, 255 )
	love.graphics.setBackgroundColor(25,25,25)
	love.graphics.setMode(900,900,false)  --set to TRUE for FULL SCREEN
	love.graphics.setColorMode("replace")
	--LOAD PLAYER1 DATA
    player1 = {
        grid_x = 2 * 21,
        grid_y = 3 * 21,
        act_x = 2 * 21,
        act_y = 3 * 21,
        speed = 10,
        image = blonde_right,
        map = 1
    }
    --LOAD PLAYER2 DATA
    player2 = {
        grid_x = 2 * 21,
        grid_y = 15 * 21,
        act_x = 2 * 21,
        act_y = 15 * 21,
        speed = 10,
        image = red_right,
        map = 1
    }
    maps = {
    	--MAP 1
    	{   { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
        	{ 1, 0, 0, 0, 0, 0, 0, 0, 1, 2, 0, 0, 0, 1 },
        	{ 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 0, 1 },
        	{ 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 0, 1, 0, 1 },
        	{ 1, 2, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1 },
        	{ 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1 },
        	{ 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1 },
        	{ 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1 },
        	{ 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1 },
        	{ 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
        	{ 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1 },
        	{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 },
        	{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
        },
        --MAP 2
    	{   { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1 },
    		{ 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1 },
    		{ 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1 },
    		{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
    		{ 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 },
    		{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
    	},
    	--MAP 3
	{	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1},
		{1,1,1,0,1,0,1,1,1,1,1,0,1,0,1,1,1,0,1,1,1},
		{1,0,0,0,0,0,1,0,1,0,1,0,0,0,1,0,1,0,0,0,1},
		{1,0,1,1,1,1,1,0,1,0,1,1,1,1,1,0,1,0,1,1,1},
		{1,0,1,0,0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1},
		{1,1,1,0,1,1,1,1,1,1,1,0,1,0,1,1,1,1,1,1,1},
		{1,0,0,0,0,0,1,0,1,0,0,0,0,0,0,0,1,0,0,0,1},
		{1,0,1,1,1,1,1,0,1,1,1,0,1,1,1,0,1,0,1,0,1},
		{1,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,1,0,1,0,1},
		{1,0,1,1,1,1,1,0,1,1,1,0,1,0,1,1,1,1,1,0,1},
		{1,0,1,0,0,0,0,0,1,0,0,0,1,0,1,0,0,0,0,0,1},
		{1,1,1,1,1,0,1,1,1,0,1,1,1,0,1,0,1,1,1,0,1},
		{1,0,1,0,1,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,1},
		{1,0,1,0,1,0,1,1,1,1,1,1,1,0,1,1,1,0,1,1,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1},
		{1,0,1,0,1,1,1,1,1,0,1,1,1,1,1,1,1,0,1,0,1},
		{1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1},
		{1,0,1,1,1,1,1,1,1,0,1,1,1,0,1,1,1,1,1,0,1},
		{1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
     },
        --MAP 4
        {   { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 2, 1, 0, 0, 0, 0, 1 },
    		{ 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1 },
    		{ 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1 },
    		{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1 },
    		{ 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1 },
    		{ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 },
    		{ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }
    	}
    	--[[   
    	--BLANK MAP
	{	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1},
		{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}
     },
        --]]
    }
end

function love.draw()
	if gamestate == "menu" then
		if starthover then
			love.graphics.draw(button_start_active, 300, 100)
			love.graphics.draw(button_rules, 300, 300)
			love.graphics.draw(button_quit, 300, 500)
		elseif ruleshover then
			love.graphics.draw(button_rules_active, 300, 300)
			love.graphics.draw(button_start, 300, 100)
			love.graphics.draw(button_quit, 300, 500)
		elseif quithover then
			love.graphics.draw(button_quit_active, 300, 500)
			love.graphics.draw(button_start, 300, 100)
			love.graphics.draw(button_rules, 300, 300)
		else
			love.graphics.draw(button_start, 300, 100)
			love.graphics.draw(button_rules, 300, 300)
			love.graphics.draw(button_quit, 300, 500)
		end
	elseif gamestate == "game" then
		
		--ANIMATION
		anim:draw(500, 500)
		--PRINT CLOCK
		time = currentTime - startTime
		time = string.format("%.1f", time)
		love.graphics.printf("TIMER:\n", 500, 0, 100, "center")
		love.graphics.printf(time, 500, 10, 100, "center")
	
		--PRINT WINNER
		winner = "PLAYER 1 WINS"
		if (winner ~= "PLAYER") then
			love.graphics.printf(winner, 500, 60, 100, "center")
		end
		--DRAW TOP MAP
		currentMap = maps[player1.map]
		for y=1, #currentMap do
			for x=1, #currentMap[y] do
				if currentMap[y][x] == 1 then
					love.graphics.draw(brick, x * 21, y * 21)
				elseif currentMap[y][x] == 2 then
					love.graphics.draw(ladder, x * 21, y * 21)
				end
			end
		end
	
		--DRAW BOTTOM MAP
		currentMap = maps[player2.map]
		for y=1, #currentMap do
			for x=1, #currentMap[y] do
				if currentMap[y][x] == 1 then
					love.graphics.draw(brick, x * 21, (y * 21) + 384)
				elseif currentMap[y][x] == 2 then
					love.graphics.draw(ladder, x * 21, (y * 21) + 384)
				end
			end
		end
	
		--DRAW PLAYER1
		love.graphics.draw(player1.image, player1.act_x, player1.act_y)

		--DRAW PLAYER2
		love.graphics.draw(player2.image, player2.act_x, player2.act_y)

	end
end

function love.update(dt)

	if gamestate == "menu" then
		if CheckCollision(300, 100, 122, 250) then
			starthover = true
		else
			starthover = false
		end
		if CheckCollision(300, 300, 122, 250) then
			ruleshover = true
		else
			ruleshover = false
		end
		if CheckCollision(300, 500, 122, 250) then
			quithover = true
		else
			quithover = false
		end
	elseif  gamestate == "game" then
		--ANIMATION
		anim:update(dt)
		--UPDATE PLAYER1 DATA
		player1.act_y = player1.act_y - ((player1.act_y - player1.grid_y) * player1.speed * dt)
		player1.act_x = player1.act_x - ((player1.act_x - player1.grid_x) * player1.speed * dt)
		--UPDATE PLAYER2 DATA
		player2.act_y = player2.act_y - ((player2.act_y - player2.grid_y) * player2.speed * dt)
		player2.act_x = player2.act_x - ((player2.act_x - player2.grid_x) * player2.speed * dt)
	
		--UPDATE TIMER
		currentTime = love.timer.getTime()
	
		--CHECK PUZZLE SOLVED CONDITION
		if player1.solved == true then
			love.audio.play(soundVictory)
			player1.map = player1.map + 1
			
			player1.solved = false
		end
		if player2.solved == true then
			love.audio.play(soundVictory)
			player2.map = player2.map + 1
			player2.solved = false
		end
	end
end

function love.keypressed(key)
	--PLAYER 1 MOVEMENT
    if key == "up" then
    	player1.image = blonde_up
        if testMap(player1, 0, -1) then
            player1.grid_y = player1.grid_y - 21
        end
    elseif key == "down" then
    	player1.image = blonde_down
        if testMap(player1, 0, 1) then
            player1.grid_y = player1.grid_y + 21
        end
    elseif key == "left" then
    	player1.image = blonde_left
        if testMap(player1, -1, 0) then
            player1.grid_x = player1.grid_x - 21
        end
    elseif key == "right" then
    	player1.image = blonde_right
        if testMap(player1, 1, 0) then
            player1.grid_x = player1.grid_x + 21
        end
    end
    
    --PLAYER 2 MOVEMENT
    if key == "w" then
    	player2.image = red_up
        if testMap(player2, 0, -1) then
            player2.grid_y = player2.grid_y - 21
        end
    elseif key == "s" then
    	player2.image = red_down
        if testMap(player2, 0, 1) then
            player2.grid_y = player2.grid_y + 21
        end
    elseif key == "a" then
    	player2.image = red_left
        if testMap(player2, -1, 0) then
            player2.grid_x = player2.grid_x - 21
        end
    elseif key == "d" then
    	player2.image = red_right
        if testMap(player2, 1, 0) then
            player2.grid_x = player2.grid_x + 21
        end
    end
end

function testMap(player, x, y)
		currentMap = maps[player.map]
	--JUSTIFY IF PLAYER 2
	yPosition = player1.grid_y
	if player == player2 then
		yPosition = player.grid_y - 384
	end
	--CHECK IF PLAYER SOLVED MAZE
	if currentMap[(yPosition / 21) + y][(player.grid_x / 21) + x] == 2 then
		player.solved = true
		startTime = love.timer.getTime()
        return true   
    --VERIFY PLAYER MOVEMENT
    elseif currentMap[(yPosition / 21) + y][(player.grid_x / 21) + x] == 0 then
        return true
    end
    
    return false
end

function testMap2(x, y)
		currentMap = maps[player2.map]
	--CHECK IF PLAYER SOLVED MAZE
	if currentMap[((player2.grid_y-384) / 21) + y][(player2.grid_x / 21) + x] == 2 then
		player.solved = true
		startTime = love.timer.getTime()
        return true   
    --VERIFY PLAYER MOVEMENT
    elseif currentMap[((player2.grid_y-384) / 21) + y][(player2.grid_x / 21) + x] == 0 then
        return true
    end
    
    return false
end

function love.mousepressed(x,y,k)
	if k == "l" then
		if CheckCollision(x, y, 1, 1, 300, 100, 211, 250) then -- Same collision check as above, except we use the x and y from the function
			gamestate = "game"								  -- instead of love.mouse.getX() and love.mouse.getY()
		else
			love.graphics.printf("Not STARTING", 300, 50, 100, "center")
		end
	end
end


function CheckCollision(x2, y2, h2, w2) -- for mouse collisions;
	x1 = love.mouse.getX()
	y1 = love.mouse.getY()
	h1 = 1
	w1 = 1
	if x1 > (x2 + w2) or (x1 + w1) < x2 then return false end --A better solution might be writing a function specifically for "collisions" in the menu.
	if y1 > (y2 + h2) or (y1 + h1) < y2 then return false end
	return true
end
